#python

#---Import---
import lx #@UnresolvedImport
import sys
import time
import inspect

from fs_modoModules.runtime import RunTime
from fs_modoModules.dialogs import Dialogs


#---Info---
lx.out("--------------------------------------------------")
lx.out("Author: Fredrik Stenson // fredrik@stenson.tv")
lx.out("www.modo.stenson.tv")
lx.out("Script: fs_BatchRender.py")
lx.out("Version: 1.0.100808 // Designed For: 401")
lx.out("")

#---Create Class Instances--- 
runtime = RunTime()
dialog = Dialogs()

try:
    
    #---Variables Setup---
    args = lx.args()
    scenes_n = lx.eval('query sceneservice scene.N ?')
    path_scene_check = ''
    scene_index = []
    render_scenes =[]
    
    if 'pop' in args:
            lx.eval('layout.create title:"Batch Render" width:250 height:100 style:palette')
            lx.eval('viewport.restore newType:attrform')
            lx.eval('attr.viewExport {fs_BatchRender:sheet} set')
    
    if 'render' in args:
        
        for i in range(scenes_n):
            scene_index.append(lx.eval('query sceneservice scene.index ? %s' %i))
            lx.out(scene_index[i])
            lx.eval('scene.set %s' %scene_index[i])
            
            path_scene = lx.eval('query sceneservice scene.file ? selected')
            
            #check to see if there's any unsaved scenes...
            sceneFile = lx.eval('query sceneservice scene.file ? %s' %i)
            if sceneFile == None:
                dialog.error_dialog('Error', 'There is an unsaved scene that is open. Save it and try again!')
                sys.exit('Unsaved Scene')
            
            lx.eval('user.value fs_batchrender_layered')
            img_type = lx.eval('user.value fs_batchrender_layered ?')
            
            path_scene_check = path_scene
            save_file = dialog.save_file_dialog(path_scene, img_type)
            render_scenes.append(save_file)

            
        #clear the event log from prev render logs...
        try:
            lx.eval('!!log.subClear render')
        except:
            pass
        
        #start the global timer for all renders...    
        timer_start_global = runtime.event_timer('start', 0)

        scene_nr = 1
        
        for i in range(len(scene_index)):
            
            lx.eval('scene.set %s' %scene_index[i])
            render_scene = render_scenes[i]
            
            #reverse the string, so the file ending is the 4 first characters...
            render_scene[0] = render_scene[0][::-1]
            
            #cut away the file ending, ex .png 
            render_scene[0] = render_scene[0][4:]
            
            #reverse again to the proper order...
            render_scene[0] = render_scene[0][::-1]
            
            timer_start_local = runtime.event_timer('start', 0)
            lx.eval('render.animation "%s" %s' %(render_scene[0], render_scene[1]))
            
            lx.eval('log.subSave render "%s_Renderlog.txt"' %render_scene[0])
            lx.eval('!!log.subClear render')
            
            timer_time_local = runtime.event_timer('stop', timer_start_local)
            
            
            #open the saved render log so we can save the total render time...
            file = open(render_scene[0] + '_Renderlog.txt', 'a')
            local_time = '\n\nTotal time for this scene: %s' %timer_time_local

            file.write(local_time)
            file.close()

            
        #stop the timer and output it to the even log...    
        timer_time_global = runtime.event_timer('stop', timer_start_global)
        lx.out('Total time to render all %s scenes: %s' %(i+1, timer_time_global))

        dialog.info_dialog('Done', timer_time_global)
    
except:
    runtime.error_script()
lx.out("--------------------------------------------------")